//
// Code Header to jump-start Fargo II C Program
//	v 1.1
// -- Must be first file in project!!
// Bryan Turner
//
//
// The ONLY changes needed to this file are:
//		Change program description

extern void main( void );

asm void __Startup__()
{
start:
	dc.w 0x0032;		// Fargo II signature for programs
	dc.l 'EXE ','APPL';	// Fargo II program info
	dc.w 0;				// ? library memory handles list
	dc.w count2+14;		// ? count
	dc.w count1+16;		// ? count
	dc.w reloc_table+18;	// Relocation table
	dc.w export_list+20;	// Export list
	dc.w prog_desc+22;	// Program comment
	dc.w 1;				// ? flags

export_list:
	dc.w 1;				// Number of exported symbols
	dc.w prog_code+28;	// Offset to first symbol
	
prog_desc:
// --- YOUR PROGRAM'S DESCRIPTION ---
//
//
	dc.b "Xinu Demo - Bryan Turner";
//
// 
//-----------------------------------

prog_code:
	jmp main;				// Jump to main (so it will get compiled in!)

count1:
	dc.w	0;	// ? Don't mess with it
count2:
	dc.w	0;	// ? Don't mess with it
	
reloc_table:
	dc.w	0;	// Number of libraries
	dc.w	0;	// Offset to library names
	
lib_names:
	dc.w	0;	// Actual library names
}

