/* getmem.c - getmem */

#include <Globals.h>

/*------------------------------------------------------------------------
 * getmem  --  allocate heap storage, returning lowest WORD address
 *------------------------------------------------------------------------
 */
#undef q
//
// BT: eventually use TI-OS routines
//
WORD	*getmem(nbytes)
	unsigned nbytes;
{
	short sr; 
	long a4;    
	//struct	mblock	*p, *q, *leftover;
	long *top = (long *)0x5D36;		// --- NOT ROM 2.1 Compatable
	
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
/*
	if (nbytes==0 || memlist.mnext== (struct mblock *) NULL) {
		RestoreA4AndSR(a4,sr);
		return( (WORD *)SYSERR);
	}
	nbytes = (unsigned int) roundmb(nbytes);
	for (q= &memlist,p=memlist.mnext ;
	     p != (struct mblock *) NULL ;
	     q=p,p=p->mnext)
		if ( p->mlen == nbytes) {
			q->mnext = p->mnext;
			RestoreA4AndSR(a4,sr);
			return( (WORD *)p );
		} else if ( p->mlen > nbytes ) {
			leftover = (struct mblock *)( (unsigned)p + nbytes );
			q->mnext = leftover;
			leftover->mnext = p->mnext;
			leftover->mlen = p->mlen - nbytes;
			RestoreA4AndSR(a4,sr);
			return( (WORD *)p );
		}
	RestoreA4AndSR(a4,sr);
	return( (WORD *)SYSERR );
*/

	// --- BT: Dumb algorithm, change it!
	// Remove memory off the top of the heap.
	// Do not store any info for deleting or reallocating.
	//
	if (nbytes==0 )
		{
		RestoreA4AndSR(a4,sr);
		return( (WORD *)SYSERR);
		}
	
	nbytes = (unsigned int) roundmb(nbytes);
	
	*top -= nbytes;

	RestoreA4AndSR(a4,sr);
	return( (WORD *)(*top) );
}
