/* insert.c  -  insert */


#include <Globals.h>

/*------------------------------------------------------------------------
 * insert.c  --  insert an process into a q list in key order
 *------------------------------------------------------------------------
 */

void InsertByKey( PROC_ID theProc, Q_ID theQueue, short theKey )
{
	QItem *Prev;
#define theQ ((QItem *)theQueue)
#define theP ((QItem *)theProc)

	if ( theKey != 0 )
		{
		Prev = (QItem *)((char *)theQ + theQ->prev);
		while ( Prev->key >= theKey )	// Go backwards through list, Queue head has key == 0
			(char *)Prev += Prev->prev;
		}
	else
		Prev = theQ;	// For keys == 0, insert right after the header node...
	
	theP->prev = (long)Prev - (long)theProc;
	theP->next = ((long)Prev + Prev->next) - (long)theProc;
	theP->key  = theKey;
	
	((QItem *)((char *)Prev + Prev->next))->prev = -(theP->next);
	Prev->next = -(theP->prev);

#undef theQ
#undef theP
}







