/* screate.c - screate, newsem */

#include <Globals.h>

/*------------------------------------------------------------------------
 * screate  --  create and initialize a semaphore, returning its id
 *------------------------------------------------------------------------
 */


SEM_ID screate( short count )
{
	short sr; 
	long a4;    
	QItem *theSem;
	
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	// Just grab a new queue, and we're almost done!
	if ( count < 0 ||
		(theSem = (QItem *)NewQueue()) == (QItem *)SYSERR )
		{
		RestoreA4AndSR(a4,sr);
		return (SEM_ID)SYSERR;
		}
	
	theSem->key   = count;		// Initialize semaphore count
	theSem->flags = SEM_FLAG;	// Tell the memory manager we're a semaphore..
	
	RestoreA4AndSR(a4,sr);
	return (SEM_ID)theSem;
}

