/* signal.c - signal */

#include <Globals.h>

/*------------------------------------------------------------------------
 * signal  --  signal a semaphore, releasing one waiting process
 *------------------------------------------------------------------------
 */

SYSCALL signal( SEM_ID theSemaphore )
{
	short sr; 
	long a4;    
#define theSem ((QItem *)theSemaphore)

	
	
	if (isbadsem(theSem) ||
		theSem->key == SFREE)
		return(SYSERR);
		
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	if ((theSem->key++) < 0)
		ready( (PROC_ID)GetFirst((Q_ID)theSem), RESCHYES );
	
	RestoreA4AndSR(a4,sr);
	return(OK);
#undef theSem
}




