/* sleep10.c - sleep10 */

#include <Globals.h>

/*------------------------------------------------------------------------
 * sleep10  --  delay the caller for a time specified in tenths of seconds
 *------------------------------------------------------------------------
 */


SYSCALL	sleep10( short n )
{
	short sr; 
	long a4;
	
	if ( n < 0 )
		return(SYSERR);

	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	if (n > 0)		// sleep10(0) -> end time slice
		{
		n <<= 1;	// Multiply sleep time by 2 (since 1/10 sec is == 2 clock ticks)
		InsertByDelta( xinuGlobs.CurPID, xinuGlobs.sleepQ, n );
		areProcsAsleep = TRUE;
		sltop = &(((QItem *)((char *)(xinuGlobs.sleepQ) + ((QItem *)(xinuGlobs.sleepQ))->next))->key);
		((Process *)(xinuGlobs.CurPID))->pstate = PRSLEEP;
		}
	resched();
    RestoreA4AndSR(a4,sr);
	return(OK);
}



