/* getitem.c - getfirst, getlast */

#include <Globals.h>

/*------------------------------------------------------------------------
 * getfirst  --	 remove and return the first process on a list
 *------------------------------------------------------------------------
 */

Q_NODE GetFirst( Q_ID theQueue )
{
#define theQ ((QItem *)theQueue)

	//kprintf( "Get First" );	// --- TESTING

	if ( theQ->next == 0 )
		return (Q_NODE)EMPTY;
	else
		return (Q_NODE)Dequeue( (Q_NODE)(((char *)theQ) + theQ->next) );

#undef theQ
}


Q_NODE GetLast( Q_ID theQueue )
{
#define theQ ((QItem *)theQueue)

	//kprintf( "Get Last" );	// --- TESTING

	if ( theQ->prev == 0 )
		return (Q_NODE)EMPTY;
	else
		return (Q_NODE)Dequeue( (Q_NODE)(((char *)theQ) + theQ->prev) );

#undef theQ

}