/*------------------------------------------------------------------------
 *	panic  --  panic and abort XINU
 *------------------------------------------------------------------------
 */

#include <kernel.h>    

void panic (char *msg)
{
	short sr; 
	long a4;    
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	kprintf("Panic: %s  ", msg);	// Print message
	ret_mon();						// Then freeze the calc...
	RestoreA4AndSR(a4,sr);
}

