/* receive.c - receive */


#include <Globals.h>

/*------------------------------------------------------------------------
 *  receive  -  wait for a message and return it
 *------------------------------------------------------------------------
 */
SYSCALL	receive()
{
	short sr; 
	long a4;    
	WORD	msg;
#define curProc ((Process *)xinuGlobs.CurPID)

	a4 = SaveA4AndLoadGlobals();
	sr = disable();

	if ( !curProc->phasmsg )	/* if no message, wait for one	*/
		{
		curProc->pstate = PRRECV;
		resched();
		}
	
	msg = curProc->pmsg;			/* retrieve message		*/
	curProc->phasmsg = FALSE;
	RestoreA4AndSR(a4,sr);
	return(msg);
}
