/* signaln.c - signaln */

#include <Globals.h>

/*------------------------------------------------------------------------
 *  signaln -- signal a semaphore n times
 *------------------------------------------------------------------------
 */


SYSCALL signaln( SEM_ID theSemaphore, short count )
{
	short sr; 
	long a4;    
#define theSem ((QItem *)theSemaphore)

	if (isbadsem( theSem) ||
		theSem->key == SFREE ||
		count <= 0)
		return(SYSERR);

	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	for (; count > 0  ; count--)
		if ((theSem->key++) < 0)
			ready( (PROC_ID)GetFirst( (Q_ID)theSem ), RESCHNO);
	resched();
	
	RestoreA4AndSR(a4,sr);
	return(OK);
	
#undef theSem
}
